//3600000, 60000
var CONSTANTS = {
	daylight_fade: 1800000,
	daylight_fade_delay: 30000
};

var GLOBALS = {
	init_status: 0,
	version_db: "http://www.tastyapps.com/flappie.txt",
	no_button: null,
	info_button: null,
	front_progress_indicator: null,
	progress_indicator: null,
	scroller: null,
	scroll_area: null,
	httpRequest: null,
	character: null,
	weather_checker: null,
	weather: {temp: null, sun_up: null, sun_down: null},
	shaker: null,
	sound_played: null,
	max_population: 6,
	update_interval: 24
};

count = ""

function setup(pNewVersionAvailable) {

/*  DEBUG CODE ---------------------
  count = count + "*" + pNewVersionAvailable + GLOBALS.init_status + "*";
  stat.innerText = count;
------------------------------
*/
     if(GLOBALS.init_status == 1) {
		GLOBALS.init_status = 2;
		if(pNewVersionAvailable) {
			var vObject = document.getElementById("upgrade_dlg");
			if(vObject) {			
				GLOBALS.front_progress_indicator.stop();
				vObject.style.display = "block";
			} else setup();
		} else setup();
	} else if(GLOBALS.init_status == 2) {
		var vObject = document.getElementById("upgrade_dlg");
		if(vObject) vObject.style.display = "none";
		if(!widget.preferenceForKey("location_code")) showPrefs();
		else {
			GLOBALS.init_status = 3;
			setup();
		}
	} else if(GLOBALS.init_status == 3) {
		GLOBALS.no_button.onclick = function() {
			var vObject = document.getElementById("upgrade_dlg");
			if(vObject) {
				vObject.style.display = "none";
				vObject = document.getElementById("front_inited");
				if(vObject) vObject.style.display = "block";
			}
		};
		
		GLOBALS.character = document.getElementById("character");
		GLOBALS.character.slice = 1;
		GLOBALS.character.base_mood = new Array();
		var vObject = new Object();
		vObject.mood = "normal";
		vObject.cycles = -1;
		GLOBALS.character.dead = false;
		GLOBALS.character.base_mood.unshift(vObject);
		GLOBALS.character.current_mood = GLOBALS.character.base_mood[0];
		GLOBALS.character.current_needs = new Array();
		GLOBALS.character.current_needs["eat"] = false;
		GLOBALS.character.current_needs["play"] = false;
		GLOBALS.character.current_needs["discipline"] = false;
		GLOBALS.character.current_needs["sleep"] = false;
		GLOBALS.character.food_need = 1;
		GLOBALS.character.food_points = widget.preferenceForKey("food_points");
		if(!GLOBALS.character.food_points) GLOBALS.character.food_points = 0;
		GLOBALS.character.play_need = 1;
		GLOBALS.character.play_points = widget.preferenceForKey("play_points");
		if(!GLOBALS.character.play_points) GLOBALS.character.play_points = 0;
		GLOBALS.character.sleep = 0;
		GLOBALS.character.sleep_schedule = null;
		GLOBALS.character.mood_queue = new Array();
		GLOBALS.character.animation = null;
		
		var vValue = widget.preferenceForKey("dead");
		if(vValue) character_kill();
		else {
			vValue = widget.preferenceForKey("asleep");
			if(!vValue) vValue = 0;
			character_set_sleep(vValue);
		}
		
		getWeather();	
		if(!GLOBALS.character.dead) {
			character_init_animation();
		}
		
		setTimeout("check_for_updates();", GLOBALS.update_interval * 60 * 60 * 1000);		
	} else if(GLOBALS.init_status == 0) {
		GLOBALS.info_button = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs);
		var vButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", savePrefs);
		GLOBALS.no_button = new AppleGlassButton(document.getElementById("upgrade_dlg_no"), "No", function() { setup(); });
		vButton = new AppleGlassButton(document.getElementById("upgrade_dlg_yes"), "Yes", function() { widget.openURL("http://www.tastyapps.com"); } );
		
		GLOBALS.front_progress_indicator = new ProgressIndicator(document.getElementById("front_progression_wheel"), "Images/prog/prog");
		GLOBALS.front_progress_indicator.start();
		GLOBALS.progress_indicator = new ProgressIndicator(document.getElementById("progression_wheel"), "Images/prog/prog");
		
		GLOBALS.scroller = new AppleVerticalScrollbar(document.getElementById("city_fetch_result_scrollbar"));
		GLOBALS.scroll_area = new AppleScrollArea(document.getElementById("city_fetch_choices"), GLOBALS.scroller);
		GLOBALS.scroll_area.scrollsHorizontally = false;
		
		vButton = document.getElementById("restart_button");
		if(vButton) {
			vButton.addEventListener("mouseover", function(pEvent) { document.getElementById("restart_button").src="Images/revive_hover.png"; }, true);
			vButton.addEventListener("mouseout", function(pEvent) { document.getElementById("restart_button").src="Images/revive.png"; }, true);
			vButton.addEventListener("click", character_revive, true);
		}
		vButton = document.getElementById("eat_button");
		if(vButton) {
			vButton.addEventListener("mouseover", function(pEvent) { button_ui("eat_button", true); }, true);
			vButton.addEventListener("mouseout", function(pEvent) { button_ui("eat_button", false); }, true);
			vButton.addEventListener("click", function(pEvent) { button_click("eat_button"); }, true);
			vButton.click_count = 0;
		}
		vButton = document.getElementById("play_button");
		if(vButton) {
			vButton.addEventListener("mouseover", function(pEvent) { button_ui("play_button", true); }, true);
			vButton.addEventListener("mouseout", function(pEvent) { button_ui("play_button", false); }, true);
			vButton.addEventListener("click", function(pEvent) { button_click("play_button"); }, true);
			vButton.click_count = 0;
		}
		vButton = document.getElementById("discipline_button");
		if(vButton) {
			vButton.addEventListener("mouseover", function(pEvent) { button_ui("discipline_button", true); }, true);
			vButton.addEventListener("mouseout", function(pEvent) { button_ui("discipline_button", false); }, true);
			vButton.addEventListener("click", function(pEvent) { button_click("discipline_button"); }, true);
			vButton.click_count = 0;
		}
		vButton = document.getElementById("sleep_button");
		if(vButton) {
			vButton.addEventListener("mouseover", function(pEvent) { button_ui("sleep_button", true); }, true);
			vButton.addEventListener("mouseout", function(pEvent) { button_ui("sleep_button", false); }, true);
			vButton.addEventListener("click", function(pEvent) { button_click("sleep_button"); }, true);
			vButton.click_count = 0;
		}
		vButton = document.getElementById("city_pref");
		if(vButton) {
			vButton.addEventListener("change", function(pEvent) { document.getElementById("city_pref").location_code = ""; }, true);
		}
		
		GLOBALS.init_status = 1;
		widget_vcheck_textdb(GLOBALS.version_db, "", setup)
		
	}
}

function character_init_animation() {
	GLOBALS.character.animation = setTimeout(character_animation, 130);
	
	widget.onshow = function () {
		if(GLOBALS && GLOBALS.character && !GLOBALS.character.animation) GLOBALS.character.animation = setTimeout(character_animation, 130);
		button_pulse_unpause("eat_button");
		button_pulse_unpause("play_button");
		button_pulse_unpause("discipline_button");
		button_pulse_unpause("sleep_button");
	};
	widget.onhide = function () {
		if(GLOBALS && GLOBALS.character && GLOBALS.character.animation) {
			clearTimeout(GLOBALS.character.animation);
			GLOBALS.character.animation = null;
		}
		button_pulse_pause("eat_button");
		button_pulse_pause("play_button");
		button_pulse_pause("discipline_button");
		button_pulse_pause("sleep_button");
	};
}
function character_animation() {
	if(GLOBALS.character) {
		if(GLOBALS.character.current_mood.cycles == 0) GLOBALS.character.current_mood = GLOBALS.character.base_mood[0];
		
		GLOBALS.character.src = "Images/moods/" + GLOBALS.character.current_mood.mood + "/" + number_pad(GLOBALS.character.slice++) + ".png";
		if(GLOBALS.character.slice > 15) {
			GLOBALS.character.slice = 1;
			if(GLOBALS.character.current_mood.cycles > 0) GLOBALS.character.current_mood.cycles -= 1;
		}
		GLOBALS.character.style.display = "block";
		document.getElementById("character_shadow").style.display = "block";
		
		var vDisplay = (GLOBALS.character.sleep == 0) ? "block" : "none";
		var vButton = document.getElementById("eat_button");
		if(vButton) vButton.style.display = vDisplay;
		vButton = document.getElementById("play_button");
		if(vButton) vButton.style.display = vDisplay;
		vButton = document.getElementById("discipline_button");
		if(vButton) vButton.style.display = vDisplay;
		
		if(GLOBALS.character.current_needs["eat"] || (GLOBALS.character.food_points < GLOBALS.character.food_need)) button_pulse_start("eat_button");
		else button_pulse_stop("eat_button");
		if(GLOBALS.character.current_needs["play"] || (GLOBALS.character.play_points < GLOBALS.character.play_need)) button_pulse_start("play_button");
		else button_pulse_stop("play_button");
		if(GLOBALS.character.current_needs["discipline"]) button_pulse_start("discipline_button");
		else button_pulse_stop("discipline_button");
		if(GLOBALS.character.current_needs["sleep"]) button_pulse_start("sleep_button");
		else button_pulse_stop("sleep_button");
		
		GLOBALS.character.animation = setTimeout(character_animation, 130);
	}
}
function character_set_mood(pMoodRecord) { // {mood: "", cycles:n}
	if(pMoodRecord.cycles < 0) {
		if(pMoodRecord.mood != "normal") GLOBALS.character.base_mood.unshift(pMoodRecord);
		else pMoodRecord = GLOBALS.character.base_mood[0];
	}
	GLOBALS.character.current_mood = pMoodRecord;
}
function shaker_callback(pAnimation, pNow, pFirst, pDone) {
	var vStandardized = (pNow % 75);
	var vDelta = (vStandardized / 75) * 20;
	
	if(pNow < 150) vDelta *= -1;
	else if(pNow < 300) vDelta *= 1;
	else vDelta *= -1;
	
	if(pDone) vDelta = 0;
	
	document.getElementById("front").style.left = (pAnimation.start_left + vDelta) + "px";
}
function character_remove_base_mood(pMood) {
	for(var vLoop = 0; vLoop < GLOBALS.character.base_mood.length; vLoop++) {
		if(GLOBALS.character.base_mood[vLoop].mood == pMood) {
			GLOBALS.character.base_mood.splice(vLoop, 1);
			return true;
		}
	}
	return false;
}
function character_set_sleep(pSleepMode) { // -1: auto sleep, 0: awake, 1: manual sleep
	if(GLOBALS.character.sleep_schedule) {
		clearTimeout(GLOBALS.character.sleep_schedule);
		GLOBALS.character.sleep_schedule = null;
	}
	if(pSleepMode < 0) GLOBALS.character.sleep_schedule = setTimeout("character_set_sleep(0);", getScheduledTime(6, 0, 0));
	else if(pSleepMode == 0) {
		character_remove_base_mood("sleepy");
		GLOBALS.character.sleep_schedule = setTimeout("character_set_sleep(-1);", getScheduledTime(20, 30, 0));
	}
	if(pSleepMode != 0) play_sound("sleep_sound");
	GLOBALS.character.sleep = pSleepMode;
	widget.setPreferenceForKey(GLOBALS.character.sleep, "asleep");
	GLOBALS.character.current_needs["sleep"] = (pSleepMode != 0);
	var vObject = new Object();
	if(GLOBALS.character.sleep == 0) {
		vObject.mood = "normal";
		document.getElementById("sleep_button_glass").src = "Images/buttons/sleep_button.png";
	} else {
		vObject.mood = "sleepy";
		document.getElementById("sleep_button_glass").src = "Images/buttons/wake_button.png";
	}
	vObject.cycles = -1;
	character_set_mood(vObject);
}
function character_kill() {
	GLOBALS.character.dead = true;
	widget.setPreferenceForKey(GLOBALS.character.dead, "dead");
	GLOBALS.character.style.display = "none";
	var vObject = document.getElementById("character_shadow");
	if(vObject) vObject.style.display = "none";
	vObject = document.getElementById("control_panel");
	if(vObject) vObject.style.display = "none";
	vObject = document.getElementById("death");
	if(vObject) vObject.style.display = "block";
	button_pulse_stop("eat_button");
	button_pulse_stop("play_button");
	button_pulse_stop("discipline_button");
	button_pulse_stop("sleep_button");
	
	if(GLOBALS.character.animation) {
		clearTimeout(GLOBALS.character.animation);
		GLOBALS.character.animation = null;
	}
	
	widget.onshow = null;
	widget.onhide = null;
}
function character_increase_needs() {
	GLOBALS.character.food_need += 1;
	GLOBALS.character.play_need += 1;
}
function character_revive() {
	GLOBALS.character.dead = false;
	widget.setPreferenceForKey(GLOBALS.character.dead, "dead");
	GLOBALS.character.style.display = "block";
	var vObject = document.getElementById("character_shadow");
	if(vObject) vObject.style.display = "block";
	vObject = document.getElementById("control_panel");
	if(vObject) vObject.style.display = "block";
	vObject = document.getElementById("death");
	if(vObject) vObject.style.display = "none";
	
	var vNow = new Date();
	widget.setPreferenceForKey(vNow.getTime(), "cycle_date");
	GLOBALS.character.food_points = 1;
	GLOBALS.character.play_points = 1;
	getWeather();
	
	character_init_animation();
}
function check_for_updates( ) {
	var vObject = document.getElementById("upgrade_dlg");

	if(!vObject || (vObject.style.display == "block")) return;
	widget_vcheck_textdb(GLOBALS.version_db, "", check_for_updates2)

}
function check_for_updates2(pNewVersionAvailable) {
	if(pNewVersionAvailable) {
	//if(true) {
		var vObject = document.getElementById("upgrade_dlg");
		if(vObject) {
			vObject.style.display = "block";
			vObject = document.getElementById("front_inited");
			if(vObject) vObject.style.display = "none";
		}
	}
		setTimeout("check_for_updates();", GLOBALS.update_interval * 60 * 60 * 1000);
}
function getWeather() {
	if(GLOBALS.weather_checker) clearTimeout(GLOBALS.weather_checker);
	GLOBALS.weather_checker = null;
	
	GLOBALS.httpRequest = new XMLHttpRequest();
	GLOBALS.httpRequest.target = document.getElementById("front_inited");
	GLOBALS.httpRequest.onreadystatechange = checkRequestResponse;
	GLOBALS.httpRequest.overrideMimeType("text/xml");
	GLOBALS.httpRequest.open("GET", "http://xml.weather.yahoo.com/forecastrss?p=" + encodeURIComponent(widget.preferenceForKey("location_code")), true);
	GLOBALS.httpRequest.setRequestHeader("Cache-Control", "no-cache");
	GLOBALS.httpRequest.send(null);
}
function button_ui(pButtonId, pHover) {
	vButton = document.getElementById(pButtonId + "_color");
	if(vButton) {
		vButton.mouseTracker = pHover;
		if(pHover && vButton.pulse) vButton.pulse.stop();
		if(pHover && !vButton.src.match(/hover\.png$/i)) vButton.src = vButton.src.replace(/^(.+)normal\.png$/i, '$1hover.png');
		else if(!pHover && vButton.src.match(/hover\.png$/i)) vButton.src = vButton.src.replace(/^(.+)hover\.png$/i, '$1normal.png');
	}
}
function button_click(pButtonId) {
	var vButton = document.getElementById(pButtonId);
	if(vButton) {
		vButton.click_count += 1;
		if(!vButton.timer) vButton.timer = setTimeout("button_clear_count('" + pButtonId + "');", 5 * 60* 1000);
		
		var vSound = "";
		var vObject = new Object();
		if(GLOBALS.shaker) {
			GLOBALS.shaker.stop();
			GLOBALS.shaker = null;
		}
		if(pButtonId == "eat_button") {
			if(GLOBALS.character.food_points < GLOBALS.character.food_need) {
				GLOBALS.character.food_points += 1;
				widget.setPreferenceForKey(GLOBALS.character.food_points, "food_points");
			}
			GLOBALS.character.current_needs["eat"] = false;
			if(vButton.click_count > 3) {
				GLOBALS.character.current_needs["discipline"] = true;
				vObject.mood = "sick";
				vObject.cycles = -1;
			} else {
				vObject.mood = "determined";
				vObject.cycles = 3;
			}
			vSound = "food_sound";
		} else if(pButtonId == "play_button") {
			if(GLOBALS.character.play_points < GLOBALS.character.play_need) {
				GLOBALS.character.play_points += 1;
				widget.setPreferenceForKey(GLOBALS.character.play_points, "play_points");
			}
			GLOBALS.character.current_needs["play"] = false;
			if(!character_remove_base_mood("sad") && (vButton.click_count > 3)) {
				GLOBALS.character.current_needs["discipline"] = true;
				vObject.mood = "sick";
				vObject.cycles = -1;
			} else {
				vObject.mood = "happy";
				vObject.cycles = 3;
			}
			vSound = "play_sound";
		} else if(pButtonId == "discipline_button") {
			GLOBALS.character.current_needs["discipline"] = false;
			if(!character_remove_base_mood("sick") && (vButton.click_count > 3)) {
				GLOBALS.character.current_needs["play"] = true;
				vObject.mood = "sad";
				vObject.cycles = -1;
			} else {
				vObject.mood = "mad";
				vObject.cycles = 3;
			}
			vSound = "discipline_sound";
			GLOBALS.shaker = new AppleAnimator(450, 13, 0, 900, shaker_callback);
			GLOBALS.shaker.start_left = 0;
			GLOBALS.shaker.start();
		} else if(pButtonId == "sleep_button") {
			character_set_sleep(((GLOBALS.character.sleep != 0) ? 0 : 1));
			vObject = null;
		}
		if(vSound) play_sound(vSound);
		if(vObject) character_set_mood(vObject);
	}
}
function button_clear_count(pButtonId) {
	var vButton = document.getElementById(pButtonId);
	if(vButton) {
		vButton.click_count = 0;
		vButton.timer = null;
	}
}
function button_pulse_start(pButtonId) {
	vButton = document.getElementById(pButtonId + "_alert");
	if(vButton && !vButton.pulse) {
		vButton.pulse = new AppleAnimator(1000, 13, 1.0, 0.0, button_pulse);
		vButton.pulse.button = vButton;
		vButton.pulse.start();
	}
}
function button_pulse_stop(pButtonId) {
	vButton = document.getElementById(pButtonId + "_alert");
	if(vButton && vButton.pulse) {
		vButton.pulse.stop();
		vButton.style.opacity = 0.0;
		vButton.pulse = null;
	}
}
function button_pulse_pause(pButtonId) {
	vButton = document.getElementById(pButtonId + "_alert");
	if(vButton && vButton.pulse) {
		vButton.pulse.stop();
	}
}
function button_pulse_unpause(pButtonId) {
	vButton = document.getElementById(pButtonId + "_alert");
	if(vButton && vButton.pulse) {
		vButton.pulse.start();
	}
}
function button_pulse(pAnimation, pNow, pFirst, pDone) {
	pAnimation.button.style.opacity = pNow;
	
	if(pDone) {
		pAnimation.button.pulse = null;
		if(pNow <= 0) pAnimation.button.pulse = new AppleAnimator(1000, 13, 0.0, 1.0, button_pulse);
		else pAnimation.button.pulse = new AppleAnimator(1000, 13, 1.0, 0.0, button_pulse);
		pAnimation.button.pulse.button = pAnimation.button;
		pAnimation.button.pulse.start();
	}
}

function receiveWeather(pXML) {
	if(pXML) {
		var vElements = pXML.getElementsByTagName("condition");
		if(vElements.length > 0) {
			if(((vElements[0].code >= 26) && (vElements[0].code <= 28))) GLOBALS.weather.temp = "Images/weather/cloudy.png";
			else if(((vElements[0].code >= 29) && (vElements[0].code <= 30)) || (vElements[0].code == 44)) GLOBALS.weather.temp = "Images/weather/partly_cloudy.png";
			else if(((vElements[0].code >= 9) && (vElements[0].code <= 12)) || ((vElements[0].code >= 17) && (vElements[0].code <= 18)) || (vElements[0].code == 35) || (vElements[0].code == 40)) GLOBALS.weather.temp = "Images/weather/rain.png";
			else if(((vElements[0].code >= 5) && (vElements[0].code <= 8)) || ((vElements[0].code >= 13) && (vElements[0].code <= 16)) || ((vElements[0].code >= 41) && (vElements[0].code <= 43)) || (vElements[0].code == 46)) GLOBALS.weather.temp = "Images/weather/snow.png";
			else if(((vElements[0].code >= 31) && (vElements[0].code <= 34)) || (vElements[0].code == 36)) GLOBALS.weather.temp = "Images/weather/sunny.png";
			else if((vElements[0].code == 1) || (vElements[0].code == 3) || (vElements[0].code == 4) || ((vElements[0].code >= 37) && (vElements[0].code <= 39)) || (vElements[0].code == 45) || (vElements[0].code == 47)) GLOBALS.weather.temp = "Images/weather/thunder.png";
			else if((vElements[0].code == 0) || (vElements[0].code == 2) || (vElements[0].code == 19) || (vElements[0].code == 24)) GLOBALS.weather.temp = "Images/weather/windy.png";
			else GLOBALS.weather.temp = "Images/weather/unknown.png";
		}
		
		// CALCULATE NEEDS VALUES
		var vNow = new Date();
		var vCycleDate = widget.preferenceForKey("cycle_date");
		if(!vCycleDate || (vCycleDate == 0)) vCycleDate = new Date();
		else vCycleDate = new Date(vCycleDate);
		if((vCycleDate.getDate() != vNow.getDate()) && (GLOBALS.character.sleep == 0) && ((GLOBALS.character.food_points  == 0) || (GLOBALS.character.play_points  == 0))) character_kill();
		else {
			var vHour = 0;
			if(vNow.getHours() < 8) {
				GLOBALS.character.food_need = 1;
				GLOBALS.character.food_points = 0;
				GLOBALS.character.play_need = 1;
				GLOBALS.character.play_points = 0;
				vHour = 8;
			} else if(vNow.getHours() < 16) {
				GLOBALS.character.food_need = 2;
				GLOBALS.character.play_need = 2;
				vHour = 16;
			} else {
				GLOBALS.character.food_need = 3;
				GLOBALS.character.play_need = 3;
			}
			if(GLOBALS.weather.temp.match(/cloud/i)) {
				GLOBALS.character.play_need += 1;
				GLOBALS.max_population += 1;
			} else if(GLOBALS.weather.temp.match(/rain/i)) {
				GLOBALS.character.food_need += 2;
				GLOBALS.character.play_need += 1;
				GLOBALS.max_population += 3;
			} else if(GLOBALS.weather.temp.match(/snow/i)) {
				GLOBALS.character.food_need += 1;
				GLOBALS.character.play_need += 2;
				GLOBALS.max_population += 3;
			} else if(GLOBALS.weather.temp.match(/thunder/i)) {
				GLOBALS.character.play_need += 3;
				GLOBALS.max_population += 3;
			}
			widget.setPreferenceForKey(vNow.getTime(), "cycle_date");
			widget.setPreferenceForKey(GLOBALS.character.food_points, "food_points");
			widget.setPreferenceForKey(GLOBALS.character.play_points, "play_points");
			setTimeout("character_increase_needs", getScheduledTime(vHour, 0, 0));
		}
		
		var vElements = pXML.getElementsByTagName("astronomy");
		if(vElements.length > 0) {
			GLOBALS.weather.sun_up = new Date();
			var vTokens = vElements[0].sunrise.match(/(\d+)\:(\d+)\s+(am|pm)/i);
			if(vTokens) {
				vHours = parseInt(vTokens[1]);
				if(vHours == 12) {
					if(vTokens[3].toLowerCase() == "am") vHours = 0;
				} else if(vTokens[3].toLowerCase() == "pm") vHours += 12;
				vMinutes = parseInt(vTokens[2]);
				GLOBALS.weather.sun_up.setHours(vHours, vMinutes, 0, 0);
			}
			GLOBALS.weather.sun_down = new Date();
			var vTokens = vElements[0].sunset.match(/(\d+)\:(\d+)\s+(am|pm)/i);
			if(vTokens) {
				vHours = parseInt(vTokens[1]);
				if(vHours == 12) {
					if(vTokens[3].toLowerCase() == "am") vHours = 0;
				} else if(vTokens[3].toLowerCase() == "pm") vHours += 12;
				vMinutes = parseInt(vTokens[2]);
				GLOBALS.weather.sun_down.setHours(vHours, vMinutes, 0, 0);
			}
		}
		
		var vObject = document.getElementById("weather");
		if(vObject) {
			vObject.src = GLOBALS.weather.temp;
		}
		
		// set time of day AND transition if needed
		var vNow = new Date();
		var vLimitUp = new Date(GLOBALS.weather.sun_up.getTime());
		vLimitUp.setHours(vLimitUp.getHours() + 1);
		var vLimitDown = new Date(GLOBALS.weather.sun_down.getTime());
		vLimitDown.setHours(vLimitDown.getHours() - 1);
		var vDayOpacity = 1.0;
		var vNightOpacity = 0.0;
		var vAnim = null;
		if((vNow.getTime() >= GLOBALS.weather.sun_up.getTime()) && (vNow.getTime() <= vLimitUp.getTime())) {
			vAnim = new AppleAnimator(CONSTANTS.daylight_fade, CONSTANTS.daylight_fade_delay, 1.0, 0.0, fade_day);
			vAnim.startTime = GLOBALS.weather.sun_up.getTime() - vAnim.interval;
			vAnim.going_up = true;
		} else if((vNow.getTime() <= GLOBALS.weather.sun_down.getTime()) && (vNow.getTime() >= vLimitDown.getTime())) {
			vAnim = new AppleAnimator(CONSTANTS.daylight_fade, CONSTANTS.daylight_fade_delay, 1.0, 0.0, fade_day);
			vAnim.startTime = vLimitDown.getTime() - vAnim.interval;
			vAnim.going_up = false;
		} else if(vNow.getTime() > vLimitUp.getTime()) {
			vDayOpacity = 1.0;
			vNightOpacity = 0.0;
		} else {
			vDayOpacity = 0.0;
			vNightOpacity = 1.0;
		}
		if((vNow.getTime() >= GLOBALS.weather.sun_up.getTime()) && (vNow.getTime() <= GLOBALS.weather.sun_down.getTime())) setTimeout(function() { var a = new AppleAnimator(CONSTANTS.daylight_fade, CONSTANTS.daylight_fade_delay, 1.0, 0.0, fade_day); a.going_up = false; a.start(); }, getScheduledTime(GLOBALS.weather.sun_down.getHours(), GLOBALS.weather.sun_down.getMinutes(), 0));
		else setTimeout(function() { var a = new AppleAnimator(CONSTANTS.daylight_fade, CONSTANTS.daylight_fade_delay, 1.0, 0.0, fade_day); a.going_up = true; a.start(); }, getScheduledTime(GLOBALS.weather.sun_down.getHours(), GLOBALS.weather.sun_down.getMinutes(), 0));
		if(vAnim) {
			vAnim.animate(vAnim)
			vAnim.timer = setInterval(vAnim.animate, vAnim.interval, vAnim);
		} else {
			vObject = document.getElementById("day");
			if(vObject) vObject.style.opacity = vDayOpacity;
			vObject = document.getElementById("night");
			if(vObject) {
				vObject.style.opacity = vNightOpacity;
				if(vObject.style.opacity > 0.5) {
					var vObject = document.getElementById("weather");
					if(vObject) {
						vObject.src = "Images/weather/moon.png";
					}
					GLOBALS.info_button.setStyle("white", "white");
				} else {
					GLOBALS.info_button.setStyle("black", "black");
				}
			}
		}
	}
	
	vObject = document.getElementById("front_inited");
	if(vObject) vObject.style.display = "block";
	GLOBALS.front_progress_indicator.stop();
	
	// schedule next update
	GLOBALS.weather_checker = setTimeout("getWeather();", getScheduledTime(0, 0, 0));
}
function fade_day(pAnimation, pNow, pFirst, pDone) {
	var vDay = document.getElementById("day");
	var vNight = document.getElementById("night");
	if(vDay && vNight) {
		if(pAnimation.going_up) {
			vDay.style.opacity = 1 - pNow;
			vNight.style.opacity = pNow;
		} else {
			vNight.style.opacity = 1 - pNow;
			vDay.style.opacity = pNow;
		}
		if(vNight.style.opacity >= 0.5) {
			var vObject = document.getElementById("weather");
			if(vObject) {
				vObject.src = "Images/weather/moon.png";
			}
			GLOBALS.info_button.setStyle("white", "white");
		} else {
			var vObject = document.getElementById("weather");
			if(vObject) {
				vObject.src = GLOBALS.weather.temp;
			}
			GLOBALS.info_button.setStyle("black", "black");
		}
	}
}

function prefs_prep(pAnimation, pNow, pFirst, pDone) {
	var vObject = document.getElementById("weather");
	if(vObject) vObject.style.opacity = pNow;
	vObject = document.getElementById("control_panel");
	if(vObject) vObject.style.opacity = pNow;
	if(pDone && (pNow <= 0)) showPrefs2();
}
function showPrefs() {
	var vAnim = new AppleAnimator(300, 13, 1.0, 0.0, prefs_prep);
	vAnim.start();
}
function showPrefs2() {
	var vFront = document.getElementById("front");
	var vBack = document.getElementById("back");
	
	if(window.widget) widget.prepareForTransition("ToBack");
	
	var vField = document.getElementById("population_points");
	if(vField) vField.innerText = (GLOBALS.character ? (GLOBALS.character.food_points + GLOBALS.character.play_points) : 0);
	vField = document.getElementById("city_pref");
	var vValue = widget.preferenceForKey("location_name");
	if(vValue) vField.value = vValue;
	else vField.value = "";
	var vValue = widget.preferenceForKey("location_code");
	if(vValue) vField.location_code = vValue;
	else vField.location_code = "";
	
	vFront.style.display="none";
	vBack.style.display="block";
	
	if(window.widget) setTimeout ('widget.performTransition();', 0);
}
function savePrefs() {
	var vField = document.getElementById("city_pref");
	if(vField.location_code == "") { // check again
		if(!GLOBALS.httpRequest) {
			if(vField.value == "") show_error("Please enter a city name");
			else if(vField.value.match(/^\d{1,5}/)) show_error("Invalid city name");
			else {
				show_error("");
				GLOBALS.progress_indicator.start();
				
				GLOBALS.httpRequest = new XMLHttpRequest();
				GLOBALS.httpRequest.target = vField;
				GLOBALS.httpRequest.onreadystatechange = checkRequestResponse;
				GLOBALS.httpRequest.overrideMimeType("text/xml");
				GLOBALS.httpRequest.open("GET", "http://xoap.weather.com/search/search?where=" + encodeURIComponent(vField.value), true);
				GLOBALS.httpRequest.setRequestHeader("Cache-Control", "no-cache");
				GLOBALS.httpRequest.send(null);
			}
		}
	} else hidePrefs();
}
function setPref(pID, pName) {
	if((pID != "") && (pName != "")) {
		widget.setPreferenceForKey(pName, "location_name");
		widget.setPreferenceForKey(pID, "location_code");
		
		if(GLOBALS.init_status <= 2) {
			GLOBALS.init_status = 3;
			setup();
		} else getWeather();
		
		hidePrefs();
	}
}
function citySelection(pXML) {
	var vNodes = pXML.getElementsByTagName("loc");
	if(vNodes.length == 0) show_error("City not found");
	else if(vNodes.length == 1) {
		setPref(vNodes[0].id, vNodes[0].firstChild.nodeValue);
	} else {
		var vList = document.getElementById("city_fetch_choices");
		if(vList) {
			for(var vLoop = (vList.childNodes.length - 1); vLoop >= 0; vLoop--) vList.removeChild(vList.childNodes[vLoop]);
			for(var vLoop = 0; vLoop < vNodes.length; vLoop++) {
				vListItem = document.createElement("div");
				vList.appendChild(vListItem);
				vLink = document.createElement("a");
				vListItem.appendChild(vLink);
				vLink.href = "#";
				vLink.location_name = vNodes[vLoop].firstChild.nodeValue;
				vLink.location_code = vNodes[vLoop].id;
				vLink.onclick = function() { document.getElementById("city_fetch_results").style.display = "none"; setPref(this.location_code, this.location_name); };
				vLink.appendChild(document.createTextNode(vNodes[vLoop].firstChild.nodeValue));
			}
		}
		vList = document.getElementById("city_fetch_results");
		if(vList) vList.style.display = "block";
		setTimeout ('GLOBALS.scroll_area.refresh();', 0);
	}
	GLOBALS.progress_indicator.stop();
}
function hidePrefs() {
	var vFront = document.getElementById("front");
	var vBack = document.getElementById("back");
	
	if(window.widget) widget.prepareForTransition("ToFront");
	
	vBack.style.display="none";			// hide the back
	vFront.style.display="block";		// show the front
	
	if(window.widget) setTimeout ('widget.performTransition();', 0);
	setTimeout ('hidePrefs2();', 750);
}
function hidePrefs2() {
	var vAnim = new AppleAnimator(300, 13, 0.0, 1.0, prefs_prep);
	vAnim.start();
}


function show_error(pMessage) {
	var vField = document.getElementById("city_fetch_message");
	if(vField) {
		if(pMessage != "") {
			vField.innerText = "ERR: "+ pMessage;
			vField.style.display = "block";
		} else vField.style.display = "none";
	}
}
function checkRequestResponse() {
	if(GLOBALS.httpRequest == null) return;
	
	if(GLOBALS.httpRequest.readyState == 4) {
		if(GLOBALS.httpRequest.target.id == "city_pref") {
			citySelection(GLOBALS.httpRequest.responseXML);
		} else receiveWeather(GLOBALS.httpRequest.responseXML);
		GLOBALS.httpRequest = null;
	}
}


function play_sound(pSoundID) {
	var vSound = document.getElementById(pSoundID);
	if(vSound) {
		if(GLOBALS.sound_played) {
			GLOBALS.sound_played.Stop();
			GLOBALS.sound_played = null;
		}
		GLOBALS.sound_played = vSound;
		GLOBALS.sound_played.Rewind();
		GLOBALS.sound_played.Play();
	}
}
function getScheduledTime(pHour, pMinute, pSecond) {
	var vNow = new Date();
	var vSchedule = new Date();
	vSchedule.setHours(pHour, pMinute, pSecond, 0);
	
	if(vSchedule.getTime() < vNow.getTime()) vSchedule.setFullYear(vSchedule.getFullYear(), vSchedule.getMonth(), vSchedule.getDate() + 1);
	
	return (vSchedule.getTime() - vNow.getTime());
}
function number_pad(pNumber) {
	if(pNumber < 10) return "000" + pNumber;
	if(pNumber < 100) return "00" + pNumber;
	if(pNumber < 1000) return "0" + pNumber;
	return "" + pNumber;
}

// ********************************
// *      PROGRESS INDICATOR      *
// ********************************
function ProgressIndicator(element, imageBaseURL, ghostElement) {
	this.count = 0;
	this.timer = null;
	this.element = element;
	this.element.style.display = "none";
	this.imageBaseURL = imageBaseURL;
	this.ghostElement = ghostElement;
}

ProgressIndicator.prototype = {
	start : function () {
		if(this.ghostElement) this.ghostElement.style.opacity = 0.5;
		this.element.style.display = "block";
		if (this.timer) clearInterval(this.timer);
		this.tick();
		var localThis = this;
		this.timer = setInterval(function() { localThis.tick() }, 60);
	},

	stop : function () {
		clearInterval(this.timer);
		this.element.style.display = "none";
		if(this.ghostElement) this.ghostElement.style.opacity = 1.0;
	},

	tick : function () {
		var imageURL = this.imageBaseURL + (this.count + 1) + ".png";
		this.element.src = imageURL;
		this.count = (this.count + 1) % 12;
	}
}
